package quimufu.colourful_portals.mixin;

import net.minecraft.client.texture.NativeImage;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.ModifyVariable;
import org.spongepowered.asm.mixin.injection.Redirect;

@Mixin(targets = "net/minecraft/client/texture/SpriteContents$Interpolation")
public abstract class InterpolationMixin {

    @Shadow
    protected abstract int lerp(double delta, int to, int from);

    ThreadLocal<Integer> colourBefore = new ThreadLocal<>();
    ThreadLocal<Double> delta = new ThreadLocal<>();

    @Redirect(method = "apply", at = @At(value = "INVOKE", target = "Lnet/minecraft/client/texture/NativeImage;setColor(III)V"))
    private void injected(NativeImage instance, int x, int y, int color) {
        int alpha = lerp(delta.get(), (color >> 24) & 0xFF, (colourBefore.get() >> 24) & 0xFF);

        instance.setColor(x, y, (alpha << 24) | (color & 0xFFFFFF));
    }

    @ModifyVariable(method = "apply", at = @At("STORE"), ordinal = 10)
    private int injected(int x) {
        colourBefore.set(x);
        return x;
    }

    @ModifyVariable(method = "apply", at = @At("STORE"), ordinal = 0)
    private double injected(double deltaV) {
        delta.set(deltaV);
        return deltaV;
    }
}
